
{           Copyright (c) 1985, 87 by Borland International, Inc.            }

program qsort;
{$R-   Bereichs-berprfung aus     |                               |  }
{$S-   Stack-Prfung aus            |  Erhhung der Geschwindigkeit |  }
uses Crt;

{ Eine Implementation des Quicksort-Algorithmus, der die zur Zeit
  wohl effizienteste Methode zum Sortieren von Array-Elementen
  (im Hauptspeicher des Computers) darstellt.
}

const
  max = 21;

type
  list = array[1..max] of integer;

var
  data: list;
  h,i: integer;

{ Die Prozedur QuickSort sortiert die Elemente des als A bergebenen
  Arrays (Indices von LO bis HI, inklusive). QuickSort selbst stellt nur
  eine Art Schnittstelle zum Programm dar - der tatschliche Sortier-
  proze wird von der Prozedur Sort ausgefhrt, die sich selbst rekursiv
  aufruft.
}

procedure quicksort(var a: list; Lo,Hi: integer);

procedure sort(l,r: integer);
var
  h,i,j,x,y: integer;
begin
  Write('Weiter mit RETURN: '); Readln;
  for h:=1 to max do Write(data[h]:3);
  writeln;

  i:=l; j:=r; x:=a[(l+r) DIV 2];
  repeat
    while a[i]<x do i:=i+1;
    while x<a[j] do j:=j-1;
    if i<=j then
    begin
      y:=a[i]; a[i]:=a[j]; a[j]:=y;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;

begin {quicksort};
  sort(Lo,Hi);
end;

begin { Hauptprogramm }
  Write('Die Zahlen der Vorlesung werden verwendet ...');
  Writeln;
  Write('Die Zufallszahlen werden sortiert....');
  data[1]:=85;
  data[2]:=38;
  data[3]:=57;
  data[4]:=13;
  data[5]:=45;
  data[6]:=78;
  data[7]:=21;
  data[8]:=96;
  data[9]:=63;
  data[10]:=33;
  data[11]:=46;
  data[12]:=39;
  data[13]:=56;
  data[14]:=22;
  data[15]:=81;
  data[16]:=07;
  data[17]:=64;
  data[18]:=52;
  data[19]:=97;
  data[20]:=60;
  data[21]:=11;

  quicksort(data,1,max);
  Write('Fertig. Weiter mit RETURN: '); Readln;
  for h:=1 to max do Write(data[h]:3);
  writeln;
end.
